var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => nlp
});
module.exports = __toCommonJS(src_exports);
var import_time_unit = __toESM(require("./time-unit"));
var import_string = require("./util/string");
function nlp(expression, option) {
  let targetStr = expression.replace(/[的]+/g, "").replace(/([^\d]+)\s+(\d+)/g, "$1$2").replace(/(\d+)\s+([^\d]+)/g, "$1$2");
  targetStr = (0, import_string.toCDB)(targetStr);
  targetStr = (0, import_string.translateNumber)(targetStr);
  const [startStr, ...endStr] = targetStr.split(/至|到|~|～/i);
  const startTimeUnit = new import_time_unit.default(
    startStr,
    (option == null ? void 0 : option.isPreferFuture) || false,
    (option == null ? void 0 : option.baseTime) ? new Date(option == null ? void 0 : option.baseTime) : /* @__PURE__ */ new Date()
  );
  const startTime = startTimeUnit.timeNormalization();
  let endTime = null;
  if (!startTime) {
    return null;
  }
  if (endStr.length > 0) {
    const endTimeUnit = new import_time_unit.default(
      endStr.join(""),
      (option == null ? void 0 : option.isPreferFuture) || false,
      new Date(startTime)
    );
    endTime = endTimeUnit.timeNormalization();
    return { startTime, endTime };
  }
  return startTime;
}
