import TimePoint from "./time-point";
export default class TimeUnit {
    timeExpression: string;
    tp: TimePoint;
    tpOrigin: TimePoint;
    timeBase: Date;
    isPreferFuture: boolean;
    isFirstTimeSolveContext: boolean;
    isAllDayTime: boolean;
    constructor(expTime: string, isPreferFuture: boolean, timeBase: Date);
    private checkContextTime;
    /**
     * 如果用户选项是倾向于未来时间，检查checkTimeIndex所指的时间是否是过去的时间，如果是的话，将大一级的时间设为当前时间的+1。
     * 如在晚上说“早上8点看书”，则识别为明天早上;
     * 12月31日说“3号买菜”，则识别为明年1月的3号。
     * @param checkTimeIndex tp.tunit时间数组的下标
     */
    private preferFuture;
    /**
     * 如果用户选项是倾向于未来时间，检查所指的day_of_week是否是过去的时间，如果是的话，设为下周
     * 如在周五说：周一开会，识别为下周一开会
     * @param weekday 识别出是周几（范围1-7）
     */
    private preferFutureWeek;
    private normSetYear;
    private normSetMonth;
    private normSetMonthFuzzyDay;
    private normSetDay;
    private normSetHour;
    private normSetMinute;
    private normSetSecond;
    private normSetTotal;
    private normSetBaseRelated;
    private normSetCurRelated;
    private modifyTimeBase;
    timeNormalization(): string | null;
}
