var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/util/string.ts
var string_exports = {};
__export(string_exports, {
  reverseStr: () => reverseStr,
  toCDB: () => toCDB,
  translateNumber: () => translateNumber,
  wordToNumber: () => wordToNumber
});
module.exports = __toCommonJS(string_exports);
function reverseStr(str) {
  return str.split("").reverse().join("");
}
function wordToNumber(str) {
  const chnNumChar = {
    "0": 0,
    "零": 0,
    "一": 1,
    "1": 1,
    "二": 2,
    "两": 2,
    "2": 2,
    "三": 3,
    "3": 3,
    "四": 4,
    "4": 4,
    "五": 5,
    "5": 5,
    "六": 6,
    "6": 6,
    "七": 7,
    "天": 7,
    "日": 7,
    "末": 7,
    "7": 7,
    "八": 8,
    "8": 8,
    "九": 9,
    "9": 9
  };
  return typeof chnNumChar[str] === "undefined" ? -1 : chnNumChar[str];
}
function translateNumber(str) {
  var _a, _b, _c, _d, _e, _f, _g, _h;
  let regExp;
  let targetStr = str;
  const baseRegStr = "[一二两三四五六七八九123456789]";
  regExp = new RegExp(`${baseRegStr}万${baseRegStr}(?!(千|百|十))`, "g");
  (_a = targetStr.match(regExp)) == null ? void 0 : _a.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("万").filter((s) => !!s);
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 1e4 + wordToNumber(val[1]) * 1e3;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp(`${baseRegStr}千${baseRegStr}(?!(百|十))`, "g");
  (_b = targetStr.match(regExp)) == null ? void 0 : _b.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("千").filter((s) => !!s);
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 1e3 + wordToNumber(val[1]) * 100;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp(`${baseRegStr}百${baseRegStr}(?!(十))`, "g");
  (_c = targetStr.match(regExp)) == null ? void 0 : _c.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("百").filter((s) => !!s);
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 100 + wordToNumber(val[1]) * 10;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp("[零一二两三四五六七八九]", "g");
  (_d = targetStr.match(regExp)) == null ? void 0 : _d.forEach((matchStr) => {
    targetStr = targetStr.replace(matchStr, wordToNumber(matchStr).toString());
  });
  let tmpStr = reverseStr(targetStr);
  const rule = new RegExp("[末天日](?=(周|期星))", "g");
  tmpStr = tmpStr.replace(rule, "7");
  targetStr = reverseStr(tmpStr);
  regExp = new RegExp("(?<!(周|星期))0?[0-9]?十[0-9]?", "g");
  (_e = targetStr.match(regExp)) == null ? void 0 : _e.forEach((matchStr) => {
    const val = matchStr.split("十");
    const ten = parseInt(val[0], 10) || 1;
    const num = ten * 10 + (parseInt(val[1], 10) || 0);
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp("0?[1-9]百[0-9]?[0-9]?", "g");
  (_f = targetStr.match(regExp)) == null ? void 0 : _f.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("百").filter((s) => !!s);
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 100;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 100 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp("0?[1-9]千[0-9]?[0-9]?[0-9]?", "g");
  (_g = targetStr.match(regExp)) == null ? void 0 : _g.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("千").filter((s) => !!s);
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 1e3;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 1e3 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp("[0-9]+万[0-9]?[0-9]?[0-9]?[0-9]?", "g");
  (_h = targetStr.match(regExp)) == null ? void 0 : _h.forEach((matchStr) => {
    let num = 0;
    const val = matchStr.split("万").filter((s) => !!s);
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 1e4;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 1e4 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  return targetStr;
}
function toCDB(str) {
  let tmp = "";
  for (let i = 0; i < str.length; i++) {
    if (str.charCodeAt(i) > 65248 && str.charCodeAt(i) < 65375) {
      tmp += String.fromCharCode(str.charCodeAt(i) - 65248);
    } else {
      tmp += String.fromCharCode(str.charCodeAt(i));
    }
  }
  return tmp;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  reverseStr,
  toCDB,
  translateNumber,
  wordToNumber
});
