function _toArray(arr) { return _arrayWithHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import TimeUnit from "./time-unit";
import { toCDB, translateNumber } from "./util/string";

/**
 * 处理自然语言中的时间
 * @param expression 包含时间的自然语言
 * @param {Date} option.baseTime 基准时间(默认当前时间)
 * @param {Boolean} option.isPreferFuture ?
 */
export default function nlp(expression, option) {
  // 清理语气助词
  var targetStr = expression.replace(/[的]+/g, '')
  // 删除数字与其他字符之间的空格
  .replace(/([^\d]+)\s+(\d+)/g, '$1$2').replace(/(\d+)\s+([^\d]+)/g, '$1$2');
  // 全角转半角
  targetStr = toCDB(targetStr);
  // 大写数字转化
  targetStr = translateNumber(targetStr);

  // 处理时间段
  var _targetStr$split = targetStr.split(/至|到|~|～/i),
    _targetStr$split2 = _toArray(_targetStr$split),
    startStr = _targetStr$split2[0],
    endStr = _targetStr$split2.slice(1);
  var startTimeUnit = new TimeUnit(startStr, (option === null || option === void 0 ? void 0 : option.isPreferFuture) || false, option !== null && option !== void 0 && option.baseTime ? new Date(option === null || option === void 0 ? void 0 : option.baseTime) : new Date());
  var startTime = startTimeUnit.timeNormalization();
  var endTime = null;
  if (!startTime) {
    return null;
  }
  if (endStr.length > 0) {
    // 使用开始时间作为基准，计算结束时间
    var endTimeUnit = new TimeUnit(endStr.join(''), (option === null || option === void 0 ? void 0 : option.isPreferFuture) || false, new Date(startTime));
    endTime = endTimeUnit.timeNormalization();
    return {
      startTime: startTime,
      endTime: endTime
    };
  }
  return startTime;
}