// 字符串翻转
export function reverseStr(str) {
  return str.split('').reverse().join('');
}
export function wordToNumber(str) {
  var chnNumChar = {
    '0': 0,
    '零': 0,
    '一': 1,
    '1': 1,
    '二': 2,
    '两': 2,
    '2': 2,
    '三': 3,
    '3': 3,
    '四': 4,
    '4': 4,
    '五': 5,
    '5': 5,
    '六': 6,
    '6': 6,
    '七': 7,
    '天': 7,
    '日': 7,
    '末': 7,
    '7': 7,
    '八': 8,
    '8': 8,
    '九': 9,
    '9': 9
  };
  return typeof chnNumChar[str] === 'undefined' ? -1 : chnNumChar[str];
}

// 中文数字替换
export function translateNumber(str) {
  var _targetStr$match, _targetStr$match2, _targetStr$match3, _targetStr$match4, _targetStr$match5, _targetStr$match6, _targetStr$match7, _targetStr$match8;
  var regExp;
  var targetStr = str;
  var baseRegStr = '[一二两三四五六七八九123456789]';

  // 万分位
  regExp = new RegExp("".concat(baseRegStr, "\u4E07").concat(baseRegStr, "(?!(\u5343|\u767E|\u5341))"), 'g');
  (_targetStr$match = targetStr.match(regExp)) === null || _targetStr$match === void 0 || _targetStr$match.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('万').filter(function (s) {
      return !!s;
    });
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 10000 + wordToNumber(val[1]) * 1000;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });

  // 千分位
  regExp = new RegExp("".concat(baseRegStr, "\u5343").concat(baseRegStr, "(?!(\u767E|\u5341))"), 'g');
  (_targetStr$match2 = targetStr.match(regExp)) === null || _targetStr$match2 === void 0 || _targetStr$match2.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('千').filter(function (s) {
      return !!s;
    });
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 1000 + wordToNumber(val[1]) * 100;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });

  // 百分位
  regExp = new RegExp("".concat(baseRegStr, "\u767E").concat(baseRegStr, "(?!(\u5341))"), 'g');
  (_targetStr$match3 = targetStr.match(regExp)) === null || _targetStr$match3 === void 0 || _targetStr$match3.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('百').filter(function (s) {
      return !!s;
    });
    if (val.length === 2) {
      num += wordToNumber(val[0]) * 100 + wordToNumber(val[1]) * 10;
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });

  // 个位
  regExp = new RegExp('[零一二两三四五六七八九]', 'g');
  (_targetStr$match4 = targetStr.match(regExp)) === null || _targetStr$match4 === void 0 || _targetStr$match4.forEach(function (matchStr) {
    targetStr = targetStr.replace(matchStr, wordToNumber(matchStr).toString());
  });

  // 周末
  var tmpStr = reverseStr(targetStr);
  var rule = new RegExp('[末天日](?=(周|期星))', 'g');
  tmpStr = tmpStr.replace(rule, '7');
  targetStr = reverseStr(tmpStr);

  // 十分位
  regExp = new RegExp('(?<!(周|星期))0?[0-9]?十[0-9]?', 'g');
  (_targetStr$match5 = targetStr.match(regExp)) === null || _targetStr$match5 === void 0 || _targetStr$match5.forEach(function (matchStr) {
    var val = matchStr.split('十');
    var ten = parseInt(val[0], 10) || 1;
    var num = ten * 10 + (parseInt(val[1], 10) || 0);
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp('0?[1-9]百[0-9]?[0-9]?', 'g');
  (_targetStr$match6 = targetStr.match(regExp)) === null || _targetStr$match6 === void 0 || _targetStr$match6.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('百').filter(function (s) {
      return !!s;
    });
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 100;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 100 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp('0?[1-9]千[0-9]?[0-9]?[0-9]?', 'g');
  (_targetStr$match7 = targetStr.match(regExp)) === null || _targetStr$match7 === void 0 || _targetStr$match7.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('千').filter(function (s) {
      return !!s;
    });
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 1000;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 1000 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  regExp = new RegExp('[0-9]+万[0-9]?[0-9]?[0-9]?[0-9]?', 'g');
  (_targetStr$match8 = targetStr.match(regExp)) === null || _targetStr$match8 === void 0 || _targetStr$match8.forEach(function (matchStr) {
    var num = 0;
    var val = matchStr.split('万').filter(function (s) {
      return !!s;
    });
    if (val.length === 1) {
      num += parseInt(val[0], 10) * 10000;
    } else if (val.length === 2) {
      num += parseInt(val[0], 10) * 10000 + parseInt(val[1], 10);
    }
    targetStr = targetStr.replace(matchStr, num.toString());
  });
  return targetStr;
}

// 全角转半角
export function toCDB(str) {
  var tmp = '';
  for (var i = 0; i < str.length; i++) {
    if (str.charCodeAt(i) > 65248 && str.charCodeAt(i) < 65375) {
      tmp += String.fromCharCode(str.charCodeAt(i) - 65248);
    } else {
      tmp += String.fromCharCode(str.charCodeAt(i));
    }
  }
  return tmp;
}